# Ubuntu CI Engine
# Copyright 2013 Canonical Ltd.

# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License version 3, as
# published by the Free Software Foundation.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU Affero General Public License for more details.

# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import json
import urllib2


class TicketApi(object):

    def __init__(self, url, ticket_id):
        self._url = url + '/api/v1'
        self._ticket_id = ticket_id

    def _patch(self, resource, data):
        req = urllib2.Request(resource)
        req.add_header('Content-Type', 'application/json')
        req.get_method = lambda: 'PATCH'
        urllib2.urlopen(req, json.dumps(data))

    def _patch_ticket_status(self, step, status):
        url = self._url + '/updateticketstatus/' + self._ticket_id + '/'
        self._patch(url, {'status': status, 'current_workflow_step': step})

    def set_image_waiting(self):
        self._patch_ticket_status(300, 310)

    def set_image_inprogress(self):
        self._patch_ticket_status(300, 320)

    def set_image_complete(self, success=True):
        state = 330
        if not success:
            state = 340
        self._patch_ticket_status(300, state)
